{{- if .Values.ingress.enabled -}}
{{/* hack workaround for dash in identiier. See https://stackoverflow.com/questions/63853679/helm-templating-doesnt-let-me-use-dash-in-names */}}
{{- $defaultAuthSvc := (index "kratos-public") }}
{{- $fullName := include "launch.fullname" . -}}
{{- $svcPort := .Values.service.port -}}
{{- if and .Values.ingress.className (not (semverCompare ">=1.18-0" .Capabilities.KubeVersion.GitVersion)) }}
  {{- if not (hasKey .Values.ingress.annotations "kubernetes.io/ingress.class") }}
  {{- $_ := set .Values.ingress.annotations "kubernetes.io/ingress.class" .Values.ingress.className}}
  {{- end }}
{{- end }}
{{- if semverCompare ">=1.19-0" .Capabilities.KubeVersion.GitVersion -}}
apiVersion: networking.k8s.io/v1
{{- else if semverCompare ">=1.14-0" .Capabilities.KubeVersion.GitVersion -}}
apiVersion: networking.k8s.io/v1beta1
{{- else -}}
apiVersion: extensions/v1beta1
{{- end }}
kind: Ingress
metadata:
  name: {{ $fullName }}
  labels:
    {{- include "launch.labels" . | nindent 4 }}
  {{- if .Values.ingress.certIssuer }}
  annotations:
    cert-manager.io/cluster-issuer: {{ .Values.ingress.certIssuer }}
    nginx.ingress.kubernetes.io/rewrite-target: /$1
  {{- else -}}
  {{- with .Values.ingress.annotations }}
  annotations:
    {{- toYaml . | nindent 4 }}
    nginx.ingress.kubernetes.io/rewrite-target: /$1
  {{- end }}
  {{- end }}
spec:
  {{- if .Values.ingress.tls }}
  tls:
    - hosts:
        - {{ .Values.launchUri | quote }}
      secretName: {{ $fullName }}-secret
  {{- end }}
  rules:
    - host: {{ .Values.launchUri | quote }}
      http:
        paths:
          - path: /(.*)
            pathType: Prefix
            backend:
              service:
                name: {{ $fullName }}
                port:
                  name: http
          - path: /auth/(.*)
            pathType: Prefix
            backend:
              service:
                name: {{ .Values.ingress.authSvc | default $defaultAuthSvc }}
                port:
                  name: http
{{- end }}
